From 9983a8165812d41b3f6b251f74c46cafb4c84b44 Mon Sep 17 00:00:00 2001
From: Cedric Bosdonnat <cbosdonnat@suse.com>
Date: Wed, 10 Mar 2021 12:06:06 +0100
Subject: [PATCH] openSUSE 3000 virtual network backports (#329)

* Fix the new iothreads virtual disk parameter

io_uring has recently been added as another IO policy on virtual disks.
Keep the parameter opened for changes. Also add the optional iothread ID
in case the user wants to pin a disk to some IO thread (and thus to a
CPU).

* Remove deprecated update parameter in virt.defined and virt.running

* Fix indentation of Jinja instructions in libvirt_domain.jinja

* Use more opt_attribute macro in libvirt_domain.jinja

* Unify XML indentation in libvirt_domain.jinja

* Move virt network generation tests to pytest

* Extract XML space stripping function from virt module

Stripping spaces and indentation from XML could also be useful in other
places, moving to xmlutil to help reuse.

* Fix link in virt state documentation

* Extract the XML cleanup code from virt.pool_update

The network_update code will be rather similar to the pool_update one.
In order to share the XML tree cleanup for easier comparisons, create a
helper function in the virt module.

* virt: expose more properties in virt.network_define

In order to let users define more types of virtual networks, expose more
of the libvirt virtual network properties.

* Remove useless code in virt pytest fixture

* Add virt.network_update function

In order to enhance the virt.network_defined state, a function to test
if an update is needed and update the network is needed. This is done by
the newly added virt.network_update function.

* Convert the virt network state unit tests to pytest

Converting these tests helped reducing the number of lines of code
thanks to the pytest parametrize feature. This is also the occasion to
split the big tests into smaller ones to report more meaningfull errors
and make it more readable.

* Let virt.network_update state change existing networks

Instead of simply reporting existing networks, update them if needed
like other states. Also bubble up the new properties from the
virt.define() function.

* Add virt.node_devices function

For the user to be able to pass host devices through he needs to get a
list of the devices that can be passed.

* virt: add PCI and USB host devices support to virt init and update

In quite a few cases it may be useful to pass a PCI or USB device from
the host to the VM. Add support for this in the virt.init() and
virt.update() functions.

* Convert virt domain state unit tests to pytest

While converting the virt domain-related states to pytest I realized
the __opts__["test"] == False case was not handled in some of them.
This commit also fixes the return code for virt.shutdown,
virt.powered_off, virt.snapshot and virt.rebooted states. It also
prevents the actual call to be issued in test mode.

* Add host_devices to virt running and defined states

Expose the new host_devices parameter to the virt.running and
virt.defined states.

* Convert virt _diff_nics() unit test to pytest

* virt: better compare NICs of running VMs

On a running guest, libvirt changes the XML definition of the network
interfaces of type "network" to the type of the network (for instance
bridge). In such a case the virt.update() function will find the two
NICs different even if they may not be... so we need to try harder to
compare.

* virt: hostdev network fixes

A network with hostdev forward mode has no bridge and no mac. So we need
to handle this in a few places in the virt module.

* virt: better handle comparison of hostdev NIC interfaces

When a domain has a NIC of type network pointing to a network with hostdev
forward, libvirt changes its running XML definition with a hostdev
interface with a PCI address from those in the network.

Handle this case to avoid useless interface detaching / attaching.

* virt: better compare hostdev networks

Libvirt adds the PCI addresses of the SR-IOV device virtual functions
when only providing the physical function. Those need to be removed in
order to avoid network changes for no reason in virt.network_update()

* Add xmlutil function dumping a node into a string

* Fix virtual network generated DNS XML for SRV records

libvirt network's srv element doesn't take a `name` property but a
`service` one.

* Add missing property in virt.network_define dns srv doc

* unCamelCase assertEqualUnit in virt module unit tests

In order to ease future virt module unit tests migration to pytest,
change the assertEqualUnit function to match the corresponding one in
pytest helpers.

* Backport missing virt bits

* virt.network_update: handle missing ipv4 netmask attribute

In the libvirt definition, the IPv4 netmask XML attribute may be
replaced by the prefix one. Handle this situation gracefully rather than
miserably failing.
---
 changelog/59143.added                         |    1 +
 changelog/59692.fixed                         |    1 +
 salt/modules/virt.py                          |  948 ++++++++-
 salt/states/virt.py                           |  477 ++++-
 salt/templates/virt/libvirt_domain.jinja      |  646 ++++---
 salt/templates/virt/libvirt_macros.jinja      |    3 +
 salt/templates/virt/libvirt_network.jinja     |   98 +-
 salt/utils/xmlutil.py                         |   29 +
 tests/pytests/unit/modules/virt/conftest.py   |   72 +-
 .../pytests/unit/modules/virt/test_domain.py  |  463 +++++
 .../pytests/unit/modules/virt/test_helpers.py |    1 +
 tests/pytests/unit/modules/virt/test_host.py  |  219 +++
 .../pytests/unit/modules/virt/test_network.py |  455 +++++
 tests/pytests/unit/states/virt/__init__.py    |    0
 tests/pytests/unit/states/virt/conftest.py    |   36 +
 tests/pytests/unit/states/virt/test_domain.py |  840 ++++++++
 .../pytests/unit/states/virt/test_helpers.py  |   99 +
 .../pytests/unit/states/virt/test_network.py  |  476 +++++
 tests/pytests/unit/utils/test_xmlutil.py      |   14 +
 tests/unit/modules/test_virt.py               |  135 +-
 tests/unit/states/test_virt.py                | 1703 +----------------
 21 files changed, 4391 insertions(+), 2325 deletions(-)
 create mode 100644 changelog/59143.added
 create mode 100644 changelog/59692.fixed
 create mode 100644 salt/templates/virt/libvirt_macros.jinja
 create mode 100644 tests/pytests/unit/modules/virt/test_host.py
 create mode 100644 tests/pytests/unit/modules/virt/test_network.py
 create mode 100644 tests/pytests/unit/states/virt/__init__.py
 create mode 100644 tests/pytests/unit/states/virt/conftest.py
 create mode 100644 tests/pytests/unit/states/virt/test_domain.py
 create mode 100644 tests/pytests/unit/states/virt/test_helpers.py
 create mode 100644 tests/pytests/unit/states/virt/test_network.py

diff --git a/changelog/59143.added b/changelog/59143.added
new file mode 100644
index 0000000000..802e925a53
--- /dev/null
+++ b/changelog/59143.added
@@ -0,0 +1 @@
+Add more network and PCI/USB host devices passthrough support to virt module and states
diff --git a/changelog/59692.fixed b/changelog/59692.fixed
new file mode 100644
index 0000000000..b4f4533ccc
--- /dev/null
+++ b/changelog/59692.fixed
@@ -0,0 +1 @@
+Don't fail updating network without netmask ip attribute
